<template xmlns:v-slot="http://www.w3.org/1999/XSL/Transform">
  <div class="">
    <q-resize-observer @resize="onResize"/>
    <q-table
      class="shadow-0"
      ref="table"
      :columns="columns"
      :visible-columns="visibleColumns"
      :grid="view ==='grid'"
      :row-key="rowKey"
      :separator="mSeparator"
      :table-class="[{'shadow-1': mShadow}]"
      :table-style="`background-color:white;${mTableStyle}`"
      :data="dataSource"
      :filter="mFilter"
      :filter-method="!mFilterMethod ? filterRows :mFilterMethod"
      :selection="mSelection"
      :selected.sync="selected"
      :rows-per-page-options="rowPerPageOptions"
      :pagination.sync="mPagination"
      :dense="dense"
      :wrap-cells="wrapCells"
      :loading="mLoading"
      :table-header-style="{}"
      @request="onRequest"
      :hide-bottom="hideBottom"
    >
      <template v-slot:loading>
        <div class="full-width row flex-center text-accent">
          <div class="full-height q-ma-lg">
            <q-inner-loading showing color="primary"/>
          </div>
        </div>


      </template>

      <template v-slot:no-data>
        <div v-if="!mLoading" class="full-width row flex-center text-secondary q-gutter-sm">
          <div class="full-height">
            <slot name="noDataText">
              <span class="text-bold">Aucun élément disponible</span>
            </slot>&emsp;
          </div>
        </div>
      </template>

      <q-tr
        slot="header"
        slot-scope="props"
        :props="props"
        class="font-sans"
      >
        <q-th v-if="mSelection !== 'none'" auto-width>
          <q-checkbox

            v-if="props.multipleSelect"
            v-model="props.selected"
            indeterminate-value="some"
          />
        </q-th>
        <q-th class="text-bold"
              style="font-weight: bold"
              v-for="(col) in props.cols" :key="col.name"
              :props="props">
          {{ col.label }}
        </q-th>
        <q-th auto-width>
          <template>
            <q-btn
              flat dense round
              color="grey-8" size="md"
              icon="las la-ellipsis-v"
            >
              <q-menu anchor="bottom left" self="top left">
                <q-item
                  v-for="col in columns" :key="col.name"
                  clickable tag="label" dense
                  v-ripple>
                  <q-item-section side>
                    <q-checkbox dense v-model="visibleColumns" :val="col.name"/>
                  </q-item-section>
                  <q-item-section>
                    <q-item-label>{{col.label}}</q-item-label>
                  </q-item-section>
                </q-item>
              </q-menu>
            </q-btn>
          </template>
        </q-th>
      </q-tr>

      <template slot="body" slot-scope="props">
        <q-tr
          :props="props"
          auto-height
          class='cursor-pointer wrap'
          @click.native="onRowClick(props.row)"
        >
          <q-td class="font-sans" v-if="mSelection !== 'none'" auto-width>
            <q-checkbox color="primary" v-model="props.selected"/>
          </q-td>
          <q-td
            class="font-sans"
            v-for="(col) in columns"
            :key="col.name"
            :props="props"
          >
            <template v-if="col.slot">
              <slot :name="col.name" v-bind:props="props"/>
            </template>
            <template v-else-if="typeof col.field === 'function'">
              {{ col.format ? col.format(col.field(props.row) ) : col.field(props.row)}}
            </template>
            <template v-else>
              {{col.format ? col.format(props.row[col.field]) :props.row[col.field] }}
            </template>
          </q-td>

          <q-td class="font-sans" auto-width>
              <div class="row" v-if="mode === 'edit'">
                <div class="col q-px-md q-mx-xs">
                  <q-btn
                    class="inline-block"
                    ref="btn" flat round stretch
                    v-if="canEdit"
                    :icon="editIcon"
                    size="11px"
                    @click="rowEdit(props.row)"
                  />
                </div>
                <div class="col q-px-md" style="margin-right: 2px">
                  <q-btn
                    class="inline-block"
                    v-if="showDeleteBtn"
                    ref="btn" flat round
                    :icon="removeIcon"
                    text-color="red" stretch
                    size="11px"
                    @click.stop="rowDelete(props.row)">
                    <q-tooltip>Supprimer</q-tooltip>
                  </q-btn>
                </div>
              </div>
          </q-td>
        </q-tr>
      </template>

      <template v-slot:item="props">
        <div
          @click="onRowClick(props.row)"
          class="q-pa-xs col-xs-12 col-sm-6 col-md-4 col-lg-3 grid-style-transition"
          :style="props.selected ? 'transform: scale(0.95);' : ''">
          <q-card :class="props.selected ? 'bg-grey-2' : ''">
            <q-card-section v-if="mSelection !== 'none'">
              <q-checkbox dense v-model="props.selected" :label="props.row.name"/>
            </q-card-section>
            <q-separator/>
            <q-list dense>
              <q-item v-for="col in props.cols.filter(col => col.name !== 'desc')" :key="col.name">
                <q-item-section>
                  <q-item-label>{{ col.label }}</q-item-label>
                </q-item-section>
                <q-item-section side>
                  <q-item-label>
                    <template v-if="col.slot">
                      <slot :name="col.name" v-bind:props="props"/>
                    </template>
                    <template v-else>
                      {{ col.value }}
                    </template>
                  </q-item-label>
                </q-item-section>
              </q-item>
            </q-list>
          </q-card>
        </div>
      </template>

      <template v-slot:bottom-row="cols" v-if="canAdd">
        <slot name="mBottomRow" v-bind:cols="cols">
          <q-tr v-if="mode==='edit'" class="cursor-pointer">
            <q-td colspan="100%" class="text-left">
              <a @click.prevent="onAddRowClick" class="text-primary">
                {{textButtonAdd}}
              </a>
            </q-td>
          </q-tr>
        </slot>
      </template>

      <template v-slot:[mSlotBottom]>
        <slot name="bottom"></slot>
      </template>

      <template v-slot:[mSlotTop]>
        <slot name="top"></slot>
      </template>

    </q-table>
  </div>
</template>

<script>

  export default {
    name: 'MTable',
    props: {
      rowKey: {
        type: String,
      },
      dataSource: {
        type: [Array, Object],
      },
      columns: {
        type: Array,
      },
      displayView: {
        type: String,
        default: 'list',
      },
      rowPerPageOptions: {
        type: Array,
        default: () => [5,10,20,50,100,200,500,0],
      },
      mSelection: {
        type: String,
        default: 'single',
      },
      mFilter: {
        type: [String, Object],
      },
      mFilterMethod: {
        type: Function,
        // default: this.filterRows,
      },
      mLoading: {
        type: Boolean,
        default: false,
      },
      dense: {
        type: Boolean,
        default: true,
      },
      showAddLineButton: {
        type: Boolean,
        default: true,
      },
      mShadow: {
        type: Boolean,
        default: false,
      },
      mode: {
        type: String,
        default: 'view',
        // validator: v => ["view", "edit"].includes(v),
      },
      textButtonAdd: {
        type: String,
        default: 'Ajouter une ligne',
      },

      mTableStyle: {
        type: String,
      },
      wrapCells: {
        type: Boolean,
        default: true,
      },
      mSeparator: {
        type: String,
        default: 'horizontal',
      },
      mSlotBottom: {
        type: String,
        default: '',
      },
      mSlotTop: {
        type: String,
        default: '',
      },
      pagination: {
        type: Object,
        default: () => ({
          sortBy: 'created_at',
          descending: false,
          page: 1,
          rowsPerPage: 20,
          //rowsNumber: 0,
        }),
      },

      hideBottom: {
        type: Boolean,
        default: false,
      },
      requestName: {
        type: String,
        default: '',
      },
      editIcon:{
        type: String,
        default: 'la la-pen'
      },
      removeIcon:{
        type: String,
        default: 'la la-trash-alt'
      }
    },
    data() {
      return {
        visibleColumns: [],
        mPagination: this.pagination,
        selected: [
          // initial selection//{ name: 'Ice cream sandwich' }
        ],
        lastValue: 0,
        maxHeight: 0,
        view: 'list'
      }
    },

    methods: {
      setMaxHeight(value) {
        //this.maxHeight = value
        this.$children[0].$el.style.maxHeight = (value) + 'px'
      },
      onResize(){
        if(this.$q.screen.md ||  this.$q.screen.lg || this.$q.screen.xl){
          this.$emit('update:display-view', 'list')
        }else{
          this.$emit('update:display-view', 'grid')
        }
      },

      onAddRowClick(row) {
        this.$emit('on-add-row-clicked', row)
      },

      rowDelete(row) {
        this.$emit('on-remove-row-clicked', row)
      },

      rowEdit(row) {
        this.$emit('on-edit-row-clicked', row)
      },

      onRowClick(row) {
        this.$emit('on-row-clicked', row)
      },

      // this is actually the default filtering method:
      filterRows(rows, terms, cols, getCellValue) {
        const lowerTerms = terms.expression.length ? terms.expression[0].toLowerCase() : ''
        return rows.filter(row => {
            return cols.some(col => {
              return (getCellValue(col, row) + '').toLowerCase().indexOf(lowerTerms) !== -1
            })
          },
        )
      },

      onRequest(props) {
        this.$emit('request', props)
      },
    },

    mounted() {
      this.visibleColumns = this.columns.filter(v => v.visible).map(v => v.name)
      this.onResize();
    },
    computed:{
      showDeleteBtn(){
        return !!this._events['on-remove-row-clicked']
      },
      canEdit(){
        return !!this._events['on-edit-row-clicked']
      },
      canAdd(){
        return !!this._events['on-add-row-clicked']
      },
    },

    watch: {
      selected(val) {
        this.$emit('update:selected', val)
      },
      pagination: {
        handler: function (val, oldVal) {
          this.mPagination = val
        },
        deep: true,
      },
      displayView:{
        immediate: true,
        handler: function(val, oldVal){
          this.view = val;
        }
      },

      view(){
        this.$emit('update:displayView', this.view);
      },

      mPagination: {
        handler: function (val, oldVal) {
          this.$emit('update:pagination', val)
        },
        deep: true,
      },
    },
  }
</script>

<style lang="sass">
  .my-sticky-header-table
    /* height or max-height is important */
    //height: 310px
    .q-table__top,
    .q-table__bottom,
    thead tr:first-child th
      /* bg color is important for th; just specify one */
      background-color: rgb(250, 251, 249)
    //#c1f4cd
    thead tr th
      position: sticky
      z-index: 0

    thead tr:first-child th
      top: 0
    /* this is when the loading indicator appears */










    &.q-table--loading thead tr:last-child th
      /* height of all previous header rows */
      top: 48px
</style>
